This repository has been archived on 2021-07-22. You can view files and clone it, but cannot push or open issues or pull requests.
abra/abra

700 lines
24 KiB
Plaintext
Raw Normal View History

2020-10-25 20:41:17 +00:00
#!/usr/bin/env bash
GIT_URL="https://git.autonomic.zone/coop-cloud/"
ABRA_DIR="$HOME/.abra"
2020-10-25 20:41:17 +00:00
###### Global help
2020-10-26 09:05:03 +00:00
DOC="
The cooperative cloud utility belt 🎩🐇
2020-10-25 20:41:17 +00:00
Usage:
abra [options] new [--server=<server> --domain=<domain>] <app>
abra [options] <domain> deploy
abra [options] <domain> logs [<service>]
abra [options] <domain> multilogs
abra [options] <domain> cp <src> <dst>
abra [options] <domain> run [--user=<user>] <service> <args>...
abra [options] <domain> run <service> <args>...
abra [options] <domain> secret generate <secret> <version> [<cmd>]
abra [options] <domain> secret insert <secret> <version> <data>
abra [options] server add <host> [<user>] [<port>]
abra [options] server rm <host>
abra [options] server use <host>
abra [options] server init <host>
abra [options] server ls
abra [options] upgrade
2020-10-26 14:54:55 +00:00
abra [options] <command> <args>...
2020-10-25 20:41:17 +00:00
Options:
2020-10-26 08:46:14 +00:00
-c, --config=<path> Stack configuration to use
-e, --env=<path> Environment variables to load
-h, --help Show this message and exit
-s, --stack=<path> Name of the target stack
-v, --version Show program version
See 'abra help <command>' to read about a specific subcommand.
2020-10-26 09:05:03 +00:00
"
2020-10-25 20:41:17 +00:00
# docopt parser below, refresh this parser with `docopt.sh abra`
2020-10-26 09:05:03 +00:00
# shellcheck disable=2016,1075,2154
2020-10-25 20:41:17 +00:00
docopt() { parse() { if ${DOCOPT_DOC_CHECK:-true}; then local doc_hash
if doc_hash=$(printf "%s" "$DOC" | (sha256sum 2>/dev/null || shasum -a 256)); then
if [[ ${doc_hash:0:5} != "$digest" ]]; then
stderr "The current usage doc (${doc_hash:0:5}) does not match \
what the parser was generated with (${digest})
Run \`docopt.sh\` to refresh the parser."; _return 70; fi; fi; fi
local root_idx=$1; shift; argv=("$@"); parsed_params=(); parsed_values=()
left=(); testdepth=0; local arg; while [[ ${#argv[@]} -gt 0 ]]; do
if [[ ${argv[0]} = "--" ]]; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break
elif [[ ${argv[0]} = --* ]]; then parse_long
elif [[ ${argv[0]} = -* && ${argv[0]} != "-" ]]; then parse_shorts
elif ${DOCOPT_OPTIONS_FIRST:-false}; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break; else
parsed_params+=('a'); parsed_values+=("${argv[0]}"); argv=("${argv[@]:1}"); fi
done; local idx; if ${DOCOPT_ADD_HELP:-true}; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${shorts[$idx]} = "-h" || ${longs[$idx]} = "--help" ]]; then
stdout "$trimmed_doc"; _return 0; fi; done; fi
if [[ ${DOCOPT_PROGRAM_VERSION:-false} != 'false' ]]; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${longs[$idx]} = "--version" ]]; then stdout "$DOCOPT_PROGRAM_VERSION"
_return 0; fi; done; fi; local i=0; while [[ $i -lt ${#parsed_params[@]} ]]; do
left+=("$i"); ((i++)) || true; done
if ! required "$root_idx" || [ ${#left[@]} -gt 0 ]; then error; fi; return 0; }
parse_shorts() { local token=${argv[0]}; local value; argv=("${argv[@]:1}")
[[ $token = -* && $token != --* ]] || _return 88; local remaining=${token#-}
while [[ -n $remaining ]]; do local short="-${remaining:0:1}"
remaining="${remaining:1}"; local i=0; local similar=(); local match=false
for o in "${shorts[@]}"; do if [[ $o = "$short" ]]; then similar+=("$short")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ ${#similar[@]} -gt 1 ]]; then
error "${short} is specified ambiguously ${#similar[@]} times"
elif [[ ${#similar[@]} -lt 1 ]]; then match=${#shorts[@]}; value=true
shorts+=("$short"); longs+=(''); argcounts+=(0); else value=false
if [[ ${argcounts[$match]} -ne 0 ]]; then if [[ $remaining = '' ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${short} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
else value=$remaining; remaining=''; fi; fi; if [[ $value = false ]]; then
value=true; fi; fi; parsed_params+=("$match"); parsed_values+=("$value"); done
}; parse_long() { local token=${argv[0]}; local long=${token%%=*}
local value=${token#*=}; local argcount; argv=("${argv[@]:1}")
[[ $token = --* ]] || _return 88; if [[ $token = *=* ]]; then eq='='; else eq=''
value=false; fi; local i=0; local similar=(); local match=false
for o in "${longs[@]}"; do if [[ $o = "$long" ]]; then similar+=("$long")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ $match = false ]]; then i=0; for o in "${longs[@]}"; do
if [[ $o = $long* ]]; then similar+=("$long"); [[ $match = false ]] && match=$i
fi; ((i++)) || true; done; fi; if [[ ${#similar[@]} -gt 1 ]]; then
error "${long} is not a unique prefix: ${similar[*]}?"
elif [[ ${#similar[@]} -lt 1 ]]; then
[[ $eq = '=' ]] && argcount=1 || argcount=0; match=${#shorts[@]}
[[ $argcount -eq 0 ]] && value=true; shorts+=(''); longs+=("$long")
argcounts+=("$argcount"); else if [[ ${argcounts[$match]} -eq 0 ]]; then
if [[ $value != false ]]; then
error "${longs[$match]} must not have an argument"; fi
elif [[ $value = false ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${long} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
fi; if [[ $value = false ]]; then value=true; fi; fi; parsed_params+=("$match")
parsed_values+=("$value"); }; required() { local initial_left=("${left[@]}")
local node_idx; ((testdepth++)) || true; for node_idx in "$@"; do
if ! "node_$node_idx"; then left=("${initial_left[@]}"); ((testdepth--)) || true
return 1; fi; done; if [[ $((--testdepth)) -eq 0 ]]; then
left=("${initial_left[@]}"); for node_idx in "$@"; do "node_$node_idx"; done; fi
2020-10-26 09:05:03 +00:00
return 0; }; either() { local initial_left=("${left[@]}"); local best_match_idx
local match_count; local node_idx; ((testdepth++)) || true
for node_idx in "$@"; do if "node_$node_idx"; then
if [[ -z $match_count || ${#left[@]} -lt $match_count ]]; then
best_match_idx=$node_idx; match_count=${#left[@]}; fi; fi
left=("${initial_left[@]}"); done; ((testdepth--)) || true
if [[ -n $best_match_idx ]]; then "node_$best_match_idx"; return 0; fi
left=("${initial_left[@]}"); return 1; }; optional() { local node_idx
for node_idx in "$@"; do "node_$node_idx"; done; return 0; }; oneormore() {
local i=0; local prev=${#left[@]}; while "node_$1"; do ((i++)) || true
[[ $prev -eq ${#left[@]} ]] && break; prev=${#left[@]}; done
if [[ $i -ge 1 ]]; then return 0; fi; return 1; }; _command() { local i
local name=${2:-$1}; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = 'a' ]]; then
if [[ ${parsed_values[$l]} != "$name" ]]; then return 1; fi
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++)) || true"; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; switch() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
2020-10-26 08:46:14 +00:00
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++))" || true; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; value() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; local value
value=$(printf -- "%q" "${parsed_values[$l]}"); if [[ $3 = true ]]; then
eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
2020-10-25 20:41:17 +00:00
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1080}
usage=${DOC:40:722}; digest=14148; shorts=(-h -c -s -e -v '' '' '')
longs=(--help --config --stack --env --version --server --domain --user)
argcounts=(0 1 1 1 0 1 1 1); node_0(){ switch __help 0; }; node_1(){
value __config 1; }; node_2(){ value __stack 2; }; node_3(){ value __env 3; }
node_4(){ switch __version 4; }; node_5(){ value __server 5; }; node_6(){
value __domain 6; }; node_7(){ value __user 7; }; node_8(){ value _app_ a; }
node_9(){ value _domain_ a; }; node_10(){ value _service_ a; }; node_11(){
value _src_ a; }; node_12(){ value _dst_ a; }; node_13(){ value _args_ a true; }
node_14(){ value _secret_ a; }; node_15(){ value _version_ a; }; node_16(){
value _cmd_ a; }; node_17(){ value _data_ a; }; node_18(){ value _host_ a; }
node_19(){ value _user_ a; }; node_20(){ value _port_ a; }; node_21(){
value _command_ a; }; node_22(){ _command new; }; node_23(){ _command deploy; }
node_24(){ _command logs; }; node_25(){ _command multilogs; }; node_26(){
_command cp; }; node_27(){ _command run; }; node_28(){ _command secret; }
node_29(){ _command generate; }; node_30(){ _command insert; }; node_31(){
_command server; }; node_32(){ _command add; }; node_33(){ _command rm; }
node_34(){ _command use; }; node_35(){ _command init; }; node_36(){ _command ls
}; node_37(){ _command upgrade; }; node_38(){ optional 0 1 2 3 4; }; node_39(){
optional 38; }; node_40(){ optional 5 6; }; node_41(){ required 39 22 40 8; }
node_42(){ required 39 9 23; }; node_43(){ optional 10; }; node_44(){
required 39 9 24 43; }; node_45(){ required 39 9 25; }; node_46(){
required 39 9 26 11 12; }; node_47(){ optional 7; }; node_48(){ oneormore 13; }
node_49(){ required 39 9 27 47 10 48; }; node_50(){ required 39 9 27 10 48; }
node_51(){ optional 16; }; node_52(){ required 39 9 28 29 14 15 51; }
node_53(){ required 39 9 28 30 14 15 17; }; node_54(){ optional 19; }
node_55(){ optional 20; }; node_56(){ required 39 31 32 18 54 55; }; node_57(){
required 39 31 33 18; }; node_58(){ required 39 31 34 18; }; node_59(){
required 39 31 35 18; }; node_60(){ required 39 31 36; }; node_61(){
required 39 37; }; node_62(){ required 39 21 48; }; node_63(){
either 41 42 44 45 46 49 50 52 53 56 57 58 59 60 61 62; }; node_64(){
required 63; }; cat <<<' docopt_exit() { [[ -n $1 ]] && printf "%s\n" "$1" >&2
printf "%s\n" "${DOC:40:722}" >&2; exit 1; }'; unset var___help var___config \
var___stack var___env var___version var___server var___domain var___user \
var__app_ var__domain_ var__service_ var__src_ var__dst_ var__args_ \
var__secret_ var__version_ var__cmd_ var__data_ var__host_ var__user_ \
var__port_ var__command_ var_new var_deploy var_logs var_multilogs var_cp \
var_run var_secret var_generate var_insert var_server var_add var_rm var_use \
var_init var_ls var_upgrade; parse 64 "$@"; local prefix=${DOCOPT_PREFIX:-''}
unset "${prefix}__help" "${prefix}__config" "${prefix}__stack" \
"${prefix}__env" "${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__user" "${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" \
"${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}_command_" "${prefix}new" \
"${prefix}deploy" "${prefix}logs" "${prefix}multilogs" "${prefix}cp" \
"${prefix}run" "${prefix}secret" "${prefix}generate" "${prefix}insert" \
"${prefix}server" "${prefix}add" "${prefix}rm" "${prefix}use" "${prefix}init" \
"${prefix}ls" "${prefix}upgrade"; eval "${prefix}"'__help=${var___help:-false}'
2020-10-26 16:19:32 +00:00
eval "${prefix}"'__config=${var___config:-}'
2020-10-26 16:30:37 +00:00
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__domain=${var___domain:-}'
eval "${prefix}"'__user=${var___user:-}'; eval "${prefix}"'_app_=${var__app_:-}'
eval "${prefix}"'_domain_=${var__domain_:-}'
2020-10-26 14:54:55 +00:00
eval "${prefix}"'_service_=${var__service_:-}'
eval "${prefix}"'_src_=${var__src_:-}'; eval "${prefix}"'_dst_=${var__dst_:-}'
2020-10-26 09:05:03 +00:00
if declare -p var__args_ >/dev/null 2>&1; then
eval "${prefix}"'_args_=("${var__args_[@]}")'; else eval "${prefix}"'_args_=()'
fi; eval "${prefix}"'_secret_=${var__secret_:-}'
eval "${prefix}"'_version_=${var__version_:-}'
eval "${prefix}"'_cmd_=${var__cmd_:-}'; eval "${prefix}"'_data_=${var__data_:-}'
eval "${prefix}"'_host_=${var__host_:-}'
eval "${prefix}"'_user_=${var__user_:-}'
eval "${prefix}"'_port_=${var__port_:-}'
2020-10-26 14:54:55 +00:00
eval "${prefix}"'_command_=${var__command_:-}'
eval "${prefix}"'new=${var_new:-false}'
eval "${prefix}"'deploy=${var_deploy:-false}'
eval "${prefix}"'logs=${var_logs:-false}'
eval "${prefix}"'multilogs=${var_multilogs:-false}'
eval "${prefix}"'cp=${var_cp:-false}'; eval "${prefix}"'run=${var_run:-false}'
eval "${prefix}"'secret=${var_secret:-false}'
eval "${prefix}"'generate=${var_generate:-false}'
eval "${prefix}"'insert=${var_insert:-false}'
eval "${prefix}"'server=${var_server:-false}'
eval "${prefix}"'add=${var_add:-false}'; eval "${prefix}"'rm=${var_rm:-false}'
eval "${prefix}"'use=${var_use:-false}'
eval "${prefix}"'init=${var_init:-false}'; eval "${prefix}"'ls=${var_ls:-false}'
eval "${prefix}"'upgrade=${var_upgrade:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
declare -p "${prefix}__help" "${prefix}__config" "${prefix}__stack" \
"${prefix}__env" "${prefix}__version" "${prefix}__server" "${prefix}__domain" \
"${prefix}__user" "${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" \
"${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}_command_" "${prefix}new" \
"${prefix}deploy" "${prefix}logs" "${prefix}multilogs" "${prefix}cp" \
"${prefix}run" "${prefix}secret" "${prefix}generate" "${prefix}insert" \
"${prefix}server" "${prefix}add" "${prefix}rm" "${prefix}use" "${prefix}init" \
"${prefix}ls" "${prefix}upgrade"; done; }
2020-10-25 20:41:17 +00:00
# docopt parser above, complete command for generating this parser is `docopt.sh abra`
2020-09-13 22:16:46 +00:00
2020-09-13 21:33:55 +00:00
PROGRAM_NAME=$(basename "$0")
2020-09-13 22:16:46 +00:00
###### Utility functions
error() {
echo "$(tput setaf 1)ERROR: $*$(tput sgr0)"
exit 1
2020-09-23 09:53:34 +00:00
}
warning() {
echo "$(tput setaf 3)WARNING: $*$(tput sgr0)"
}
success() {
echo "$(tput setaf 2)$*$(tput sgr0)"
}
###### Default settings
if [ -z "$COMPOSE_FILE" ]; then
COMPOSE_FILE="compose.yml"
fi
if [ -z "$ABRA_STACK_DIR" ]; then
ABRA_STACK_DIR="stacks/$SERVICE"
2020-09-13 22:16:46 +00:00
fi
###### Safety checks
2020-09-24 22:36:23 +00:00
require_multitail() {
if ! type multitail > /dev/null 2>&1; then
error "multitail program is not installed"
fi
2020-09-24 22:36:23 +00:00
}
require_abra_dir() {
mkdir -p "$ABRA_DIR"
}
2020-09-23 09:53:34 +00:00
require_stack() {
if [ -z "$STACK_NAME" ]; then
2020-10-26 17:36:28 +00:00
error "no stack_name, export \$STACK_NAME=my_cool_app"
fi
2020-09-23 09:53:34 +00:00
}
require_stack_dir() {
# FIXME 3wc: replace with APP_DIR
if [ -z "$ABRA_STACK_DIR" ] || [ ! -d "$ABRA_STACK_DIR" ]; then
error "can't find \$ABRA_STACK_DIR '$ABRA_STACK_DIR'"
fi
2020-09-23 09:53:34 +00:00
}
2020-09-11 10:58:11 +00:00
# FIXME 3wc: update or remove
if [ -z "$ABRA_ENV" ] && [ -f .envrc ] && type direnv > /dev/null 2>&1 && ! direnv status | grep -q 'Found RC allowed true'; then
error "direnv is blocked, run direnv allow"
2020-09-07 21:29:29 +00:00
fi
2020-09-08 06:49:27 +00:00
2020-10-26 11:46:54 +00:00
###### Run-time loading
2020-10-26 11:46:54 +00:00
load_custom_commands() {
if [ -f abra-commands.sh ]; then
# shellcheck disable=SC1091
source abra-commands.sh
fi
if [ -f "$ABRA_STACK_DIR/abra-commands.sh" ]; then
2020-10-26 17:02:24 +00:00
# shellcheck disable=SC1091
source "$ABRA_STACK_DIR/abra-commands.sh"
fi
2020-10-26 11:46:54 +00:00
}
load_instance() {
# FIXME 3wc: try and support old behaviour of just specifying -a STACK
DOMAIN="$abra__domain_"
ENV_FILE=$(find ~/.abra -name "$DOMAIN.env")
if [ "$(echo "$ENV_FILE" | wc -l)" -gt 1 ]; then
error "Found $DOMAIN in multiple servers: $ENV_FILE"
fi
IFS='/' read -r -a PARTS <<< "$ENV_FILE"
SERVER="${PARTS[-2]}"
export STACK_NAME="${DOMAIN//./_}"
}
load_instance_env() {
# shellcheck disable=SC1090
source "$ENV_FILE"
if [ -z "$APP" ]; then
error "APP not set, maybe $ENV_FILE is using an old format?"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
export DOCKER_CONTEXT="$SERVER"
export DOMAIN
}
2020-10-26 11:46:54 +00:00
load_context() {
# Load current context from env or Docker
if [ -z "$DOCKER_CONTEXT" ]; then
warning "\$DOCKER_CONTEXT not set, (slowly) looking it up"
# shellcheck disable=SC2063
DOCKER_CONTEXT=$(docker context ls | grep '*' | cut -d' ' -f1)
# make sure grep doesn't parse this, we want a literal '*'
fi
2020-10-26 11:46:54 +00:00
}
###### Subcommand `secret`
sub_secret_insert() {
load_instance
load_instance_env
SECRET="$abra__secret_"
VERSION="$abra__version_"
PW="$abra__data_"
if [ -z "$SECRET" ] || [ -z "$VERSION" ] || [ -z "$PW" ]; then
error "Required arguments missing"
fi
echo "$PW" | docker secret create "${STACK_NAME}_${SECRET}_${VERSION}" - > /dev/null
if type pass > /dev/null 2>&1; then
echo "$PW" | pass insert "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}" -m > /dev/null
success "pass: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}"
fi
}
sub_secret_generate(){
load_instance
load_instance_env
SECRET="$abra__secret_"
VERSION="$abra__version_"
PWGEN=${abra__cmd_:-pwqgen}
if [ -z "$SECRET" ] || [ -z "$VERSION" ]; then
error "Required arguments missing"
fi
PW=$($PWGEN)
success "Password: $PW"
# FIXME 3wc: this is a little janky, might be better to make a
# util_secret_insert function which this and sub_secret_insert can call
abra__data_="$PW"
2020-09-07 21:29:29 +00:00
sub_secret_insert
}
###### Subcommand `run`
sub_run(){
load_instance
if [ -n "$abra___user" ]; then
RUN_USER="-u $abra___user"
fi
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
| grep "${STACK_NAME}_${abra__app_}" | head -n1 | cut -d',' -f1)
2020-09-08 06:49:27 +00:00
if [ -z "$CONTAINER" ]; then
error "Can't find a container for ${STACK_NAME}_${abra__app_}"
exit
fi
# shellcheck disable=SC2086
docker exec $RUN_USER -it "$CONTAINER" "$@"
2020-09-07 21:29:29 +00:00
return
2020-09-07 21:29:29 +00:00
}
###### Subcommand `new`
sub_new (){
require_abra_dir
APP=$abra__app_
SERVER=$abra___server
DOMAIN=$abra___domain
if [ -z "$SERVER" ]; then
shopt -s nullglob dotglob
SERVERS=(~/.abra/servers/*)
shopt -u nullglob dotglob
echo "Where would you like to put $APP?"
echo -n "$(tput setaf 4)"
for i in "${!SERVERS[@]}"; do
printf " %s)\t%s\n" "$i" "${SERVERS[$i]}"
done
echo -n "$(tput sgr0)"
read -rp "Choose server 0-$i, or Ctrl+C to quit: " SERVER_CHOICE
SERVER="${SERVERS[$SERVER_CHOICE]}"
else
SERVER="$ABRA_DIR/servers/$SERVER"
fi
if [ ! -d "$SERVER" ]; then
error "Server '$SERVER' not found"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
if [ ! -d "$APP_DIR" ]; then
# FIXME 3wc: move to require_app_clone or something
warning "'$APP' not found, fetching via git.."
git clone "$GIT_URL/$APP.git" "$ABRA_DIR/apps/$APP"
fi
if [ -z "$DOMAIN" ]; then
read -rp "Domain name: " DOMAIN
fi
ENV_FILE="$SERVER/$DOMAIN.env"
if [ -f "$ENV_FILE" ]; then
error "$ENV_FILE already exists"
# FIXME 3wc: offer to user $STACK_$DOMAIN.env name instead
fi
cp "$APP_DIR/.envrc.sample" "$ENV_FILE"
sed -i "s/$APP\.example\.com/$DOMAIN/g" "$ENV_FILE"
echo "$(tput setaf 4)Your new '$APP' is ready for action:$(tput sgr0)"
echo " $(tput setaf 3)Customise the configuration:"
echo " $ENV_FILE$(tput sgr0)"
echo " $(tput setaf 2)Deploy it:"
echo " abra deploy $DOMAIN$(tput sgr0)"
}
2020-09-07 21:29:29 +00:00
sub_deploy (){
load_instance
load_instance_env
echo "About to deploy:"
echo " Server: $(tput setaf 4)${SERVER}$(tput sgr0)"
if [ "${COMPOSE_FILE/:/}" == "${COMPOSE_FILE}" ]; then
echo " Compose: $(tput setaf 3)${APP_DIR}/${COMPOSE_FILE}$(tput sgr0)"
else
echo " Compose: $(tput setaf 3)${APP_DIR}/"
IFS=':' read -ra COMPOSE_FILES <<< "$COMPOSE_FILE"
for COMPOSE in "${COMPOSE_FILES[@]}"; do
echo " - ${COMPOSE}"
done
tput sgr0
fi
if [ -n "$DOMAIN" ]; then
echo " Domain: $(tput setaf 2)${DOMAIN}$(tput sgr0)"
fi
echo " Stack: $(tput setaf 1)${STACK_NAME}$(tput sgr0)"
read -rp "Continue? (y/[n])? " choice
case "$choice" in
y|Y ) ;;
n|N ) return;;
* ) return;;
esac
(
cd "$APP_DIR" || error "\$APP_DIR '$APP_DIR' not found"
# shellcheck disable=SC2086
if docker stack deploy -c ${COMPOSE_FILE/:/ -c } "$STACK_NAME"; then
if [ -n "$DOMAIN" ]; then
success "Yay! App should be available at https://${DOMAIN}"
else
success "Yay! That worked. No \$DOMAIN defined, check logs."
fi
else
error "Oh no! Something went wrong 😕 Check errors above"
fi
)
2020-09-07 21:29:29 +00:00
}
###### Subcommand `logs`
2020-09-24 22:48:46 +00:00
# Inspired by https://github.com/moby/moby/issues/31458#issuecomment-475411564
2020-09-24 22:36:23 +00:00
sub_multilogs() {
require_multitail
load_instance
load_instance_env
# Get a list of the service names
SERVICES=$(docker stack services --format "{{.Name}}" "${STACK_NAME}")
# Sort the service names
SERVICES=$(echo "${SERVICES}" | sort)
# Create the command to run
COMMAND='multitail --mergeall'
for SERVICE in ${SERVICES}; do
COMMAND="${COMMAND} -L 'docker service logs --tail 20 -f ${SERVICE}'"
done
# Run the command
bash -c "${COMMAND}"
2020-09-24 22:36:23 +00:00
}
2020-09-08 07:10:37 +00:00
sub_logs (){
load_instance
load_instance_env
2020-10-26 14:54:55 +00:00
SERVICE="${abra__service_}"
if [ -z "$SERVICE" ]; then
warning "No \$SERVICE provided, running multilogs"
sub_multilogs
fi
shift
if [ $# -eq 0 ]; then
LOGS_ARGS="\
--follow \
--tail 20 \
--no-trunc \
--details \
--timestamps"
else
# shellcheck disable=SC2124
LOGS_ARGS=$@
fi
# shellcheck disable=SC2086
docker service logs "${STACK_NAME}_${SERVICE}" $LOGS_ARGS
2020-09-08 07:10:37 +00:00
}
###### Subcommand `cp`
sub_cp() {
require_stack
2020-09-23 09:53:34 +00:00
2020-10-26 14:54:55 +00:00
SOURCE="${abra__src_}"
DEST="${abra__dst_}"
2020-10-26 16:19:32 +00:00
SERVICE=$(echo "$SOURCE" | grep -o '^[^:]\+:' || echo "$DEST" | grep -o '^[^:]\+:')
SERVICE=$(echo "$SERVICE" | tr -d ':')
if [ -z "$SERVICE" ]; then
echo "Usage: $PROGRAM_NAME cp SERVICE:SRC_PATH DEST_PATH"
echo " $PROGRAM_NAME cp SRC_PATH SERVICE:DEST_PATH"
echo ""
error "Can't find SERVICE in either SRC or DEST"
fi
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
| grep "${STACK_NAME}_${SERVICE}" | cut -d',' -f1)
if [ -z "$CONTAINER" ]; then
error "Can't find a container for ${STACK_NAME}_${SERVICE}"
exit
fi
CP_ARGS=$(echo "$SOURCE $DEST" | sed "s/$SERVICE:/$CONTAINER:/")
# shellcheck disable=SC2086
docker cp ${CP_ARGS}
}
2020-10-26 17:40:04 +00:00
###### Subcommand `server`
2020-10-23 03:02:39 +00:00
sub_server_init() {
2020-10-26 14:54:55 +00:00
export DOCKER_CONTEXT="${abra__host_}"
2020-10-26 09:58:15 +00:00
if [ -n "$DOCKER_CONTEXT" ]; then
load_context
fi
docker swarm init || true
docker network create --driver=overlay proxy --scope swarm || true
}
2020-10-23 03:02:39 +00:00
sub_server_add() {
HOST="$abra__host_"
USERNAME="$abra__user_"
PORT="$abra__port_"
if [ -n "$PORT" ]; then
PORT=":$PORT"
fi
if [ -n "$USERNAME" ]; then
USERNAME="$USERNAME@"
fi
docker context create "$HOST" \
--docker "host=ssh://$USERNAME$HOST$PORT"
}
2020-10-23 03:02:39 +00:00
sub_server_rm() {
docker context rm "$abra__host_"
2020-10-23 03:02:39 +00:00
}
sub_server_use() {
docker context use "$abra__host_"
}
2020-10-26 09:58:15 +00:00
sub_server_ls() {
docker context ls
2020-10-26 09:58:15 +00:00
}
2020-09-23 09:53:34 +00:00
###### Subcommand `upgrade`
sub_upgrade() {
2020-10-26 17:31:03 +00:00
curl https://install.abra.autonomic.zone | bash
2020-09-23 09:53:34 +00:00
}
###### Docker alias subcommands
sub_stack() {
# shellcheck disable=SC2068
docker stack $@
}
sub_volume() {
# shellcheck disable=SC2068
docker volume $@
}
###### Main
2020-10-26 08:46:14 +00:00
abra() {
2020-10-26 14:54:55 +00:00
# TODO (3wc): we either need to do this, or add 'shellcheck disable' all over
# the place to handle the dynamically-defined vars
declare abra___stack abra___env abra___config abra__command_ abra__args_ \
abra__secret_ abra__version_ abra__data_ abra___user abra__host_ \
abra__app_ abra__port_ abra__user_ abra__service_ abra__src_ abra__dst_ \
abra__domain_ abra___server abra___domain
2020-10-26 11:33:06 +00:00
DOCOPT_PREFIX=abra_
2020-10-26 08:46:14 +00:00
eval "$(docopt "$@")"
2020-10-26 11:33:06 +00:00
STACK_NAME=$abra___stack
if [ -n "$abra___env" ]; then
# shellcheck disable=SC1090
source "$abra___env" || error "Unable to load env from '$abra___env'"
fi
load_custom_commands
# Search for sub_* functions, and check if any of them matches enabled
# arguments (i.e. is a command and is specified)
for SUBCOMMAND in $(declare -Ff | grep 'sub_' | cut -d' ' -f3 | sort -r); do
IFS='_' read -r -a PARTS <<< "$SUBCOMMAND"
for PART in "${PARTS[@]:1}"; do
VAR=$(eval "echo \$abra_$PART")
if [ ! "$VAR" == "true" ]; then
continue 2
fi
done
abra__command_=$(IFS="_"; echo "${PARTS[*]:1}")
done
# Fallback for non-docopt-defined options
CMD="sub_${abra__command_}"
if type "$CMD" > /dev/null 2>&1; then
# shellcheck disable=SC2086
"$CMD" ${abra__args_[*]}
else
docopt_exit
fi
2020-10-26 08:46:14 +00:00
}
abra "$@"